<!DOCTYPE html>
<html>

<head>
    <title>INF226</title>
    <link rel="stylesheet" href="{{ url_for('static', filename='index.css') }}" />
	<link rel="icon" href="favicon.png" type="image/png" />
</head>

<body>
    <div id="page">
        <marquee>
            <div id="header"></div>
        </marquee>
        <main>
            <pre id="output"></pre>
        </main>
        <div id="controls">


            <label for="search">Search:</label>
            <input type="search" id="search" name="search" enterkeyhint="search" value="*">
            <button type="button" id="searchBtn">Search!</button>
            <button type="button" id="allBtn">Show all</button>
            <!--Mottageren av meldingen-->
            <label for="sender">To:</label>
            <input type="text" id="receiver" name="receiver" value="">
            <button type="button" id="sendBtn">Send</button>
            <span></span>
            <label for="message">Message:</label>
            <textarea id="message" style="grid-row: span 4;">A message...</textarea>
            <!-- log out-knappen har jeg fått hjelp av medstudenter til å lage. Den er derfor lik knappen til Filips gruppe.-->
            <button onclick="location.href='/logout'" type = "button" id = "logoutBtn">Logout</button>
        </div>
        <div id="anchor"></div>
    </div>
</body>
<script>
    
    var reqId = 0;
    var anchor = document.getElementById('anchor');
    var searchField = document.getElementById('search');
    var senderField = document.getElementById('sender');
    var messageField = document.getElementById('message');
    var receiverField = document.getElementById('receiver')
    var searchBtn = document.getElementById('searchBtn');
    var sendBtn = document.getElementById('sendBtn');
    var allBtn = document.getElementById('allBtn');
    var output = document.getElementById('output');
    var header = document.getElementById('header');


    var checkAnnouncements = async () => {
        res = await fetch('/announcements');
        anns = await res.json();
        if (anns && Array.isArray(anns.data)) {
            const elts = [];
            anns.data.forEach((element, idx) => {
                if (idx > 0) {
                    const node = document.createElement('li');
                    node.textContent = '  …  ';
                    elts.push(node);
                }
                const node = document.createElement('li');
                node.textContent = `${element.message || ''}`;
                elts.push(node);
            });
            console.log(elts);
            header.replaceChildren(...elts);
        }
    };
    var search = async (query) => {
        const id = reqId++;
        const q = `/search?q=${encodeURIComponent(query)}`;
        res = await fetch(q);
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerText = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };
    var send = async (receiver, message) => {
        const id = reqId++;
        const q = `/send?&receiver=${encodeURIComponent(receiver)}&message=${encodeURIComponent(message)}`;
        res = await fetch(q, { method: 'post' });
        console.log(res);
        const head = document.createElement('h3');
        head.textContent = `[${id}]  ${q} → ${res.status} ${res.statusText}`;
        output.appendChild(head);
        const body = document.createElement('p');
        body.innerText = await res.text();
        output.appendChild(body);
        body.scrollIntoView({block: "end", inline: "nearest", behavior: "smooth"});
        anchor.scrollIntoView();
        checkAnnouncements();
    };

    

    searchField.addEventListener('keydown', ev => {
        if (ev.key === 'Enter') {
            search(searchField.value);
        }
    });
    searchBtn.addEventListener('click', () => search(searchField.value));
    allBtn.addEventListener('click', () => search('*'));
    sendBtn.addEventListener('click', () => send(receiverField.value, messageField.value));
    checkAnnouncements();

</script>

</html>
